
/* 
   Project:     SOFTSUSY 1.2
   Date:        18.07.2001
   File:        complex.h
   Author:      Ben Allanach 
   Manual:      hep-ph/0104145 
   Webpage:     http://allanach.home.cern.ch/allanach/softsusy.html
   Description: complex numbers and operators between them

   $Log: complex.h,v $
   Revision 1.3  2001/07/18 14:42:51  allanach
   Added proper header info

   */

#ifndef COMPLEX_H
#define COMPLEX_H

#include <stdlib.h>
#include <iostream.h>
#include <math.h>
#include <def.h>
#include <utils.h>

// Incomplete as yet: needs more operators adding to it!

class Complex {
private:
  double re, im;
public:
  Complex() : re(0.0), im(0.0) {};
  Complex(double r) : re(r), im(0.0) {};
  Complex(double r, double i) : re(r), im(i) {};
  Complex(const Complex & cc) : re(cc.re), im(cc.im) {};
  const Complex &operator=(const Complex & s);

  double real() const { return re; }
  double imag() const { return im; }
  
  void setRe(double a) { re = a; }
  void setIm(double a) { im = a; }

  double mod() const;
  double arg() const;

  Complex conj() const;

  Complex operator/(double b) const;
  Complex operator*(const Complex & b) const;  
  Complex operator*(const double & a) const;
  bool operator>=(const Complex & a) const;
  Complex operator/(const Complex & a) const;
  Complex cc() const;
  Complex operator-(const Complex & a) const;
};

Complex log(const Complex &a);
Complex exp(const Complex &a);
Complex sqrt(const Complex &a);

Complex operator*(double a, const Complex & b);
Complex operator+(const Complex & a, const Complex & b);
Complex operator/(double a, const Complex & b);
Complex operator-(double b, const Complex & a);
ostream & operator <<(ostream & , const Complex &);
inline istream & operator >> (istream & left, Complex & v){
  double r, i;
  left >> r >> i;
  v.setRe(r); v.setIm(i);
  return left;
}

#endif
